#include <mycloud/mycloud.h>

#include <string.h>

int main(void){
  mcProviderConnection connection;
  mcDeployablePtr deployable;
  mcHardwareProfilePtr hwp;
  mcInstancePtr instance;
  mcInstanceInfo instance_status;

  printf("mycloud\n");

  mcInit();
  
  strcpy(connection.username, "mockuser");
  strcpy(connection.password, "mockpassword");
  strcpy(connection.type, "mock");
  strcpy(connection.target, "mock");
  mcProviderConnect(&connection);
  
  deployable = mcDeployableDefineFromFile("~/my_deployable.tpl");
  hwp = mcProviderHardwareProfileAt(connection.provider, 0);
  
  instance = mcDeployToCloud(deployable, hwp); 
  mcInstanceUpdateInfo(instance, &instance_status);
  printf("Instance is %s\n", instance_status.state_str);

  mcInstanceDeinit(instance);
  mcDeployableUndefine(deployable);
  mcProviderDisconnect(&connection);
  
  mcDeinit();
  return 0;
}
