/*
 * config.c: main internal mycloud configuration interface
 *
 * Copyright (C) 2011-2012 Red Hat, Inc.
 *
 * See COPYING.LIB for the License of this software
 *
 * Author: Mo Morsi <mmorsi@redhat.com>
 */

#include "config.h"

int configInit(mcConfigPtr config){
  // FIXME parse config & startup embedded deltacloud servers corresponding to contents
  // startup embedded deltacloud server
  // dcServerLaunch(&config->deltacloud);

  // startup embedded imagefactory server
  imgfacServerLaunch(&config->imgfac);
  
  return 0;
}

int configDeinit(mcConfigPtr config){
  mcLinkedListNodePtr current_node;
  dcServerPtr current_server;

  current_node = config->deltacloud_servers.first;
  while(current_node != NULL){
     current_server = (dcServerPtr)current_node->value;

     // terminate embedded deltacloud server
     dcServerTerm(current_server);
     current_node = current_node->next;
  }
  // TODO remove remaining nodes from list?

  // termiante embedded imagefactory server
  imgfacServerTerm (&config->imgfac);

  return 0;
}

mcConfig config;

mcConfigPtr configRetrieve(){
  return &config;
}
