/*
 * config.h: main internal mycloud configuration interface
 *
 * Copyright (C) 2011-2012 Red Hat, Inc.
 *
 * See COPYING.LIB for the License of this software
 *
 * Author: Mo Morsi <mmorsi@redhat.com>
 */


#include "provider.h"
#include "deltacloud.h"
#include "imagefactory.h"

/**
 * high level config instance, contains library-wide mycloud constructs
 */
typedef struct _mcConfig{
  mcLinkedList deltacloud_servers;    /* embedded deltacloud servers */
  imgfacServer imgfac;                /* embedded imagefactory server */
} mcConfig;

/**
 * pointer to a mcConfig
 */
typedef mcConfig *mcConfigPtr;

/**
 * intialize a mycloud configuration instance
 */
int configInit(mcConfigPtr config);

/**
 * deinitialize a mycloud configuration instance
 */
int configDeinit(mcConfigPtr config);

/** 
 * retrieve instance of the config
 */
mcConfigPtr configRetrieve();
