/*
 * deployable.h: core driver for deployable apis
 *
 * Copyright (C) 2011-2012 Red Hat, Inc.
 *
 * See COPYING.LIB for the License of this software
 *
 * Author: Mo Morsi <mmorsi@redhat.com>
 */

#ifndef __MC_CLOUD_DEPLOYABLE_H__
#define __MC_CLOUD_DEPLOYABLE_H__

#include "mycloud.h"

/**
 * MC_DEPLOYABLE_ID_BUFLEN:
 *
 * Macro providing the maximum length of the mcDeployable id string.
 * 
 */
#define MC_DEPLOYABLE_ID_BUFLEN (256 + 1)

/**
 * MC_DEPLOYABLE_NAME_BUFLEN:
 *
 * Macro providing the maximum length of the mcDeployable name string.
 * 
 */
#define MC_DEPLOYABLE_NAME_BUFLEN (256 + 1)

/**
 * MC_DEPLOYABLE_FILE_PATH_BUFLEN:
 *
 * Macro providing the maximum length of the mcDeployable file path string.
 * 
 */
#define MC_DEPLOYABLE_FILE_PATH_BUFLEN (256 + 1)

/**
 * _mcDeployable: internal representation of hardware profile
 *
 */
struct _mcDeployable{
  char id[MC_DEPLOYABLE_ID_BUFLEN];
  char name[MC_DEPLOYABLE_NAME_BUFLEN];
  char file_path[MC_DEPLOYABLE_FILE_PATH_BUFLEN];
};

/**
 * MC_DEPLOYABLE_BUILD_OUTPUT_BUFLEN:
 *
 * Macro providing the maximum size of the build command's output buffer
 * 
 */
#define MC_DEPLOYABLE_BUILD_OUTPUT_BUFLEN (512)

/**
 * build deployable using factory
 */
int deployableBuild(mcDeployablePtr deployable, mcProviderPtr provider);

/**
 * MC_DEPLOYABLE_PUSH_POLL_DELAY:
 *
 * Macro providing the interval between polls of the results of the push command
 * 
 */
#define MC_DEPLOYABLE_PUSH_POLL_DELAY 60

/**
 * push deployable to provider using factory
 */
int deployablePush(mcDeployablePtr deployable, mcProviderPtr provider);

#endif // #define __MC_CLOUD_DEPLOYABLE_H__
