/*
 * imagefactory.h: management of interface to imagefactory
 *
 * Copyright (C) 2011-2012 Red Hat, Inc.
 *
 *
 * See COPYING.LIB for the License of this software
 *
 * Author: Mo Morsi <mmorsi@redhat.com>
 */

#ifndef __MC_CLOUD_IMAGEFACTORY_H__
#define __MC_CLOUD_IMAGEFACTORY_H__

#include "util/types.h"

/**
 * imgfacServer:
 *
 * a imgfacServer is a structure representing an embedded imagefactory server
 */
typedef struct _imgfacServer {
  pid_t pid;                                  /* process id of running server */
} imgfacServer;

/**
 * imgfacServerPtr:
 *
 * a imgfacServerPtr is a pointer to the imgfacServer structure
 */
typedef imgfacServer *imgfacServerPtr;

/**
 * launch embedded imagefactory server
 */
int imgfacServerLaunch(imgfacServerPtr server);

/**
 * terminate embedded imagefactory server
 */
int imgfacServerTerm(imgfacServerPtr server);

/**
 * return boolean indicating if the embedded server is running
 */
BOOL imgfacServerIsRunning(imgfacServerPtr server);

/**
 * build deployable for target/template via imagefactory, setting the uuid of the newly built image
 */
int imgfacDeployableBuild(const char* target, const char* template_file, char* uuid);

/**
 * push deployable via imagefactory
 */
int imgfacDeployablePush(char* provider, char* uuid);

#endif // #define __MC_CLOUD_IMAGEFACTORY_H__
