/*
 * instance.c: core driver for instance apis
 *
 * Copyright (C) 2011-2012 Red Hat, Inc.
 *
 * See COPYING.LIB for the License of this software
 *
 * Author: Mo Morsi <mmorsi@redhat.com>
 */

#include "instance.h"

#include "mycloud.h"

#include <string.h>
#include <stdlib.h>

mcInstancePtr mcDeployToCloud(mcDeployablePtr deployable, mcHardwareProfilePtr hwp){
  mcInstancePtr instance;

  instance = malloc(sizeof(mcInstance));
  instance->provider = hwp->provider;
  instance->deployable = deployable;
  instance->hwp = hwp;

  // build deployable via imagefactory
  //deployableBuild(deployable, hwp->provider);

  // push deployable via imagefactory
  // FIXME push untested atm
  //deployablePush(deployable, hwp->provider);

  // launch on cloud via deltacloud
  dcCreateInstance(instance, hwp->provider);
  return instance;
}

int mcInstanceTerminate(mcInstancePtr instance){
  // stop the instance via deltacloud
  dcTerminateInstance(instance);
  
  // free it
  free(instance);
  return 0;
}

int mcInstanceDeinit(mcInstancePtr instance){
  free(instance);
  return 0;
}

int mcInstanceUpdateInfo(mcInstancePtr instance, mcInstanceInfoPtr info){
  info->state = instance->info.state;
  strncpy(info->state_str, instance->info.state_str, MC_INSTANCE_STATE_LABEL_BUFLEN);;
  return 0;
}
