/*
 * instance.h: core driver for instance
 *
 * Copyright (C) 2011-2012 Red Hat, Inc.
 *
 * See COPYING.LIB for the License of this software
 *
 * Author: Mo Morsi <mmorsi@redhat.com>
 */

#ifndef __MC_CLOUD_INSTANCE_H__
#define __MC_CLOUD_INSTANCE_H__

#include "hardwareprofile.h"

/**
 * MC_INSTANCE_NAME_BUFLEN:
 *
 * Macro providing the maximum length of the instance name string
 * 
 */
#define MC_INSTANCE_NAME_BUFLEN (256 + 1)

/**
 * MC_INSTANCE_ID_BUFLEN:
 *
 * Macro providing the maximum length of the instance id string
 * 
 */
#define MC_INSTANCE_ID_BUFLEN (256 + 1)

/**
 * MC_INSTANCE_HREF_BUFLEN:
 *
 * Macro providing the maximum length of the instance href string
 * 
 */
#define MC_INSTANCE_HREF_BUFLEN (256 + 1)

struct _mcInstance{
  mcProviderPtr provider;       /* provider to which instance belongs to */
  mcDeployablePtr deployable;   /* deployable which instance was based off of */
  mcHardwareProfilePtr hwp;     /* hardware profile used to launch instance */
  mcInstanceInfo info;          /* instance info attributes */
  char id[MC_INSTANCE_ID_BUFLEN];
  char name[MC_INSTANCE_NAME_BUFLEN];
  char href[MC_INSTANCE_HREF_BUFLEN];
};

#endif // #define __MC_CLOUD_INSTANCE_H__
