/*
 * provider.h: core driver for provider apis
 *
 * Copyright (C) 2011-2012 Red Hat, Inc.
 *
 * See COPYING.LIB for the License of this software
 *
 * Author: Mo Morsi <mmorsi@redhat.com>
 */

#ifndef __MC_CLOUD_PROVIDER_H__
#define __MC_CLOUD_PROVIDER_H__

#include "util/types.h"
#include "deltacloud.h"

struct _mcProvider{
  dcServerPtr dc_server;                             /* embedded deltacloud server for provider */
  dcConnection connection;                              /* and connection to it */
  BOOL is_connected;                                 /* boolean indicating if connection has been established */
  mcLinkedList hardwareProfiles;                     /* list of hardware profiles on the provider */
};

/**
 * initialize the internal represenation of a provider
 */
int providerInit(mcProviderPtr provider);

/**
 * deinitialize the internal represenation of a provider
 */
int providerDeinit(mcProviderPtr provider);

#endif // #define __MC_CLOUD_PROVIDER_H__
